#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include "cross_utils.h"

#include <fstream>
#include <iostream>
#include "NvJpegDecoder.h"
#include "NvJpegEncoder.h"
using namespace std;
int main(int argc,char **argv)
{
	int a=atoi(argv[1]);
	if(a==0){
		int nRet;        
		pthread_attr_t attr;
		pthread_t tid;
		CrossUtils server;

		pthread_attr_init(&attr);
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
		nRet = pthread_create(&tid, &attr, CrossUtils::ServerThreadFun, (void*)&server);
		if (nRet < 0)
		{
			printf("create server thread failed\n" );
			return -1;
		}
		ifstream* pFileStream = NULL;
		int jpgfd;
		pFileStream = new ifstream("a.jpg");
		if (pFileStream == NULL)
		{
			printf("open no signal picture file fail!\n");
			return 0;
		}

		NvJPEGDecoder *m_pJpegDec = NvJPEGDecoder::createJPEGDecoder("jpegdec");
		if (m_pJpegDec == NULL)
		{
			printf("NvJPEGDecoder::createJPEGDecoder() fail!\n");
			delete pFileStream;
			return 0;
		}

		streampos posCurrent = pFileStream->tellg();
		pFileStream->seekg(0, pFileStream->end);
		uint64_t nFileSize = pFileStream->tellg();
		pFileStream->seekg(posCurrent, pFileStream->beg);
		
		unsigned char* pFileBuffer = new unsigned char[nFileSize];
		if (pFileBuffer == NULL)
		{
			printf("malloc file buffer fail! nFileSize =%ld\n",nFileSize);
			delete pFileStream;
			return 0;
		}
		pFileStream->read((char *)pFileBuffer, nFileSize);
        
		uint32_t nWidth, nHeight, nPixFmt;
#if 1        
        int count=0;
        while(1)
        {
            if (m_pJpegDec->decodeToFd(jpgfd, pFileBuffer, nFileSize, nPixFmt, nWidth, nHeight) < 0)
            {
                printf("m_pJpegDec->decodeToFd() fail!\n");
                delete [] pFileBuffer;
                delete pFileStream;
                return 0;
            }

            if(server.Get_Flag(0)==count)
            {
                printf("server send:%d,fd:%d\n",count,jpgfd);    
		        server.ancil_send_fd(jpgfd);
            }
            else
            {
                usleep(30000);
                continue;
            }
            count++;    
            //printf("###send count:%d\n",count);
            usleep(33000);
        }
		delete [] pFileBuffer;
		delete pFileStream;
#endif
	}
	else{
		int fd;
		int dmafd;
		CrossUtils client;
		fd=client.ClientCreate();
        while(1)
        {
		    client.ancil_recv_fd(fd,&dmafd);
        }
	}
    printf("###exit\n");
    return 0;
}

